=== debian/control ===
Source: ros-humble-realsense2-camera
Section: misc
Priority: optional
Maintainer: LibRealSense ROS Team <librs.ros@intel.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, python3-numpy <!nocheck>, python3-requests <!nocheck>, python3-tqdm <!nocheck>, ros-humble-ament-cmake, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-cmake-pytest <!nocheck>, ros-humble-builtin-interfaces, ros-humble-cv-bridge, ros-humble-diagnostic-updater, ros-humble-geometry-msgs, ros-humble-image-transport, ros-humble-launch-pytest <!nocheck>, ros-humble-launch-testing <!nocheck>, ros-humble-librealsense2, ros-humble-nav-msgs, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-realsense2-camera-msgs, ros-humble-ros-environment, ros-humble-ros2topic <!nocheck>, ros-humble-sensor-msgs, ros-humble-sensor-msgs-py <!nocheck>, ros-humble-std-msgs, ros-humble-tf2, ros-humble-tf2-ros, ros-humble-tf2-ros-py <!nocheck>, ros-humble-ros-workspace
Homepage: http://www.ros.org/wiki/RealSense
Standards-Version: 3.9.2

Package: ros-humble-realsense2-camera
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-humble-builtin-interfaces, ros-humble-cv-bridge, ros-humble-diagnostic-updater, ros-humble-geometry-msgs, ros-humble-image-transport, ros-humble-launch-ros, ros-humble-librealsense2, ros-humble-nav-msgs, ros-humble-rclcpp, ros-humble-rclcpp-components, ros-humble-realsense2-camera-msgs, ros-humble-sensor-msgs, ros-humble-std-msgs, ros-humble-tf2, ros-humble-tf2-ros, ros-humble-ros-workspace
Description: RealSense camera package allowing access to Intel D400 3D cameras
